import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.Timer;
import java.util.TimerTask;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

import org.apache.commons.httpclient.Header;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.HttpException;
import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.httpclient.HttpStatus;
import org.apache.commons.httpclient.URIException;
import org.apache.commons.httpclient.methods.GetMethod;

public class Launcher {
	public static class Getter implements Runnable {
		private HttpClient client;
		private HttpMethod method;
		private int totalBytesRead;
		private boolean finished;

		public Getter(HttpClient client, String url) throws HttpException,
				IOException {
			this.client = client;
			this.method = new GetMethod(url);
			totalBytesRead = 0;
			finished = false;
		}

		public int getTotalBytesRead() {
			return totalBytesRead;
		}

		@Override
		public void run() {
			try {
				int status = client.executeMethod(method);

				if (status != HttpStatus.SC_OK) {
					// System.err.format("Method failed: %s\n",
					// method.getStatusLine());
				}

				Header[] headers = method.getResponseHeaders();

				for (Header h : headers) {
					System.out.println(h.getName() + ": " + h.getValue());
				}

				String dest = String.format("%s/%s", "/home/eugene/Desktop",
						method.getURI().getEscapedName());

				FileOutputStream out = new FileOutputStream(dest);
				InputStream stream = method.getResponseBodyAsStream();
				byte[] bytes = new byte[32];
				int bytesRead = 0;

				while ((bytesRead = stream.read(bytes)) > 0) {
					totalBytesRead += bytesRead;
					out.write(bytes, 0, bytesRead);
				}
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			finished = true;
		}

		public boolean isFinished() {
			return finished;
		}

		public String getFileName() {
			try {
				return method.getURI().getEscapedName();
			} catch (URIException e) {
			}
			return null;
		}

		public int getSize() {
			if (method.getResponseHeader("Content-Length") == null) {
				return 0;
			}
			return Integer.decode(method.getResponseHeader("Content-Length")
					.getValue());
		}
	}

	public static class GetStatus {
		private final JLabel status;
		private JButton launcher;
		private JFrame frame;
		private JProgressBar bar;

		public GetStatus(final Getter g) {
			frame = new JFrame("Test");
			status = new JLabel("Not started");
			launcher = new JButton("Start");
			bar = new JProgressBar();
			JPanel content = new JPanel();
			content.setLayout(new GridLayout(2, 1));
			content.add(status);
			content.add(bar);

			bar.setEnabled(false);
			bar.setSize(200, bar.getPreferredSize().height);
			bar.setValue(0);
			bar.setMaximum(100);
			bar.setMinimum(0);

			launcher.addActionListener(new ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					launcher.setEnabled(false);
					bar.setEnabled(true);

					final Timer timer = new Timer();
					timer.scheduleAtFixedRate(new TimerTask() {

						@Override
						public void run() {
							int a = g.getTotalBytesRead();
							int b = g.getSize();
							double p = ((double) a) / b * 100;
							bar.setValue((int) p);
							String s = String.format(
									"Bytes read: %d of %d (%f%%)", a, b, p);
							GetStatus.this.status.setText(s);
							if (g.isFinished()) {
								timer.cancel();
							}
						}
					}, 0, 50);

					Thread t = new Thread(g);
					t.start();
				}
			});

			frame.getContentPane().setLayout(new BorderLayout());
			frame.getContentPane().add(new JLabel("File: " + g.getFileName()),
					BorderLayout.NORTH);
			frame.getContentPane().add(content, BorderLayout.CENTER);
			frame.getContentPane().add(launcher, BorderLayout.SOUTH);
			frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		}

		public void start() {
			frame.pack();
			frame.setVisible(true);
		}
	}

	public static void main(String[] args) throws HttpException, IOException {
		HttpClient client = new HttpClient();

		Getter g = new Getter(client,
				"http://emarcotte.com/Testrio2/Testrio2-0.0.2-data.jar");
		GetStatus window = new GetStatus(g);
		window.start();
	}
}
